package com.bjlt.spider.bean;

import com.bjlt.spider.listener.AirSoureLineListenter;
import com.bjlt.spider.utils.request.ToolUtils;
import com.luyn.date.DateUtil;

import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.MessageConsumer;
import javax.jms.Session;
import java.util.ArrayList;
import java.util.Date;
import java.util.Hashtable;
import java.util.List;

public class ExchangeRateInstance {

    private  static Hashtable<String,Double> exchangeRate = new Hashtable<>();

    /**
     * 是否开启查询MQ
     */
    private static Boolean isStartSend = false;


    private static ExchangeRateInstance exchangeRateInstance = new ExchangeRateInstance();


    /**
     * 创建消费者的Session
     */
    private static Session session =null;

    private static Destination destination = null;

    /**
     * 查询消费者数量
     */
    private static List<MessageConsumer>  messageConsumers = new ArrayList<>();


    private static Long Sleep = 2000L;


    /**
     * 统计上一分钟的查询结果
     */
    private static Hashtable<String,List<Hashtable<String,String>>> searchmoiter = new Hashtable<>();


    public static void main(String[] args) {
        String key = DateUtil.getFormatDate(new Date(System.currentTimeMillis()-60*1000), "yyyyMMDDHHmm");

        System.out.println(key);
    }


    /**
     * 获取前5分钟查询
     * @return
     */
    public  Hashtable<String, List<Hashtable<String, String>>> getSearchmoiter() {
        Hashtable<String, List<Hashtable<String, String>>> current = new Hashtable<>();
        for (int i = 0; i < 5; i++) {
            String key = DateUtil.getFormatDate(new Date(System.currentTimeMillis()-i*60*1000), "yyyyMMDDHHmm");
            if(searchmoiter.containsKey(key)){
                List<Hashtable<String, String>> hashtables = searchmoiter.get(key);
                current.put(key,hashtables);
            }
        }
        return current;
    }

    public  Hashtable<String, List<Hashtable<String, String>>> getSearchmoiters() {

        return searchmoiter;
    }



    /**
     *设置查询次数
     * @param searchKey
     * @param type
     * @param msg
     */
    public  void setSearchmoiter(String searchKey,int type ,String msg) {
        String key = DateUtil.getFormatDate(new Date(), "yyyyMMDDHHmm");
        if(searchmoiter.containsKey(key)){
            List<Hashtable<String, String>> hashtables = searchmoiter.get(key);
            Hashtable hashtable = new Hashtable();
            hashtable.put("searhkey",searchKey);
            hashtable.put("msg",msg);
            if(type==1){
                hashtable.put("pt","bigapp");
            }else{
                hashtable.put("pt","web");
            }
            hashtables.add(hashtable);
            searchmoiter.replace(key,hashtables);
        }else{
            List<Hashtable<String, String>> hashtables = new ArrayList<>();
            Hashtable hashtable = new Hashtable();
            hashtable.put("searhkey",searchKey);
            hashtable.put("msg",msg);
            if(type==1){
                hashtable.put("pt","bigapp");
            }else{
                hashtable.put("pt","web");
            }
            hashtables.add(hashtable);
            searchmoiter.put(key,hashtables);
        }
    }

    public static ExchangeRateInstance getInstance(){
        if(ToolUtils.isEmpty(exchangeRateInstance)){
            exchangeRateInstance = new ExchangeRateInstance();
        }
        return  exchangeRateInstance;
    }

    private ExchangeRateInstance() {
        if(ToolUtils.isEmpty(exchangeRate)){
            exchangeRate = new Hashtable<>();
        }

        if(ToolUtils.isEmpty(messageConsumers)){
            messageConsumers = new ArrayList<>();
        }

        if(ToolUtils.isEmpty(searchmoiter)){
            searchmoiter = new Hashtable<>();
        }


    }


    /**
     * 获取汇率
     * @param current
     * @return
     */
    public Double getExchangeRate(String current){
        String currentkey = current+"_"+ DateUtil.getFormatDate(new Date(),"yyyy-MM-dd");
        if(ToolUtils.isEmpty(exchangeRate)){
            exchangeRate = new Hashtable<>();
        }
        if(exchangeRate.containsKey(currentkey)){
            return  exchangeRate.get(currentkey);
        }
        return null;
    }


    /**
     * 把汇率存在缓存中
     * @param current
     * @param rate
     */
    public void putExchangeRate(String current,Double rate){
        String currentkey = current+"_"+ DateUtil.getFormatDate(new Date(),"yyyy-MM-dd");
        if(ToolUtils.isEmpty(exchangeRate)){
            exchangeRate = new Hashtable<>();
        }
        if(exchangeRate.containsKey(currentkey)){
            exchangeRate.replace(currentkey, rate);
        }else{
            exchangeRate.put(currentkey,rate);
        }
    }


    /**
     * 停止发送
     */
    public void stop(){
        this.isStartSend = false;
    }

    /**
     * 查询开始
     */
    public void start(){
        this.isStartSend = true;
    }

    /**
     * 获取状态
     * @return
     */
    public Boolean getState(){
        return this.isStartSend;
    }


    /**
     * 存放session
     * @param session
     */
    public void setSession(Session session){
        ExchangeRateInstance.session = session;
    }

    /**
     * 获取session
     * @return
     */
    public  Session getSession() {
        return session;
    }

    public  Destination getDestination() {
        return destination;
    }

    public  void setDestination(Destination destination) {
        ExchangeRateInstance.destination = destination;
    }


    /**
     * 创建消费者
     * @throws JMSException
     */
    public void createMessageConsumers() throws JMSException {
        if(!ToolUtils.isEmpty(session)){
//            new Thread(()->{
//                MessageConsumer consumer = null;
//                try {
//                    consumer = ExchangeRateInstance.session.createConsumer(ExchangeRateInstance.destination);
//                    consumer.setMessageListener(new AirSoureLineListenter());
//                    messageConsumers.add(consumer);
//                } catch (JMSException e) {
//                    e.printStackTrace();
//                }
//
//            }).start();
            MessageConsumer consumer = ExchangeRateInstance.session.createConsumer(ExchangeRateInstance.destination);
            consumer.setMessageListener(new AirSoureLineListenter());
            messageConsumers.add(consumer);
        }
    }


    /**
     * 移除consumer
     * @throws JMSException
     */
    public void  removeConsumer() throws JMSException {
        if(!ToolUtils.isEmpty(messageConsumers)){
            MessageConsumer consumer = messageConsumers.remove(0);
            if(!ToolUtils.isEmpty(consumer)){
                consumer.close();

            }
        }
    }


    /**
     * 获取消费者数量
     * @return
     */
    public Integer getConsumerNumber(){
        if(ToolUtils.isEmpty(messageConsumers)){
            messageConsumers = new ArrayList<>();
        }
        return  messageConsumers.size();
    }

    public  Long getSleep() {
        if(Sleep<=0){
            Sleep = 10L;
        }
        return Sleep;
    }

    public  void removeSleep() {
        if(Sleep>100L) {
            Sleep -= 100L;
        }
    }

    public  void addSleep() {
            Sleep += 100L;
    }
}
