package com.bjlt.spider.config;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Component
public class Config {


    /**
     * mq 地址
     */
    @Value("${mqAdress}")
    private String mqAdress;


    /**
     * 查询mq的名字
     */
    @Value("${mqSearchName}")
    private String mqSearchName;

    /**
     * 查询的消费者数量
     */
    @Value("${mqSearchListenerNum}")
    private Integer mqSearchListenerNum = 1;

    /**
     * 是否开启发送查询key
     */
    @Value("${isStartSendMq}")
    private Boolean isStartSendMq = false;



    @Value("${smallMqSearchName}")
    private String smallMqSearchName;


    /**
     * 是否开启查询MQ
     */
    @Value("${isStartMqListenter}")
    private Boolean isStartMqListenter = false;

    @Value("${searchUrl}")
    private String searchUrl;





    @Value("${isSmallStartSendMq}")
    private Boolean isSmallStartSendMq = false;



    @Value("${isSmallStartMqListenter}")
    private Boolean isSmallStartMqListenter = false;


    /**
     * 全局监控
     */
     private List<Map<String,Object>>  monitor = new ArrayList<>();


    public List<Map<String, Object>> getMonitor() {
        return monitor;
    }

    public void setMonitor(List<Map<String, Object>> monitor) {
        this.monitor = monitor;
    }

    /**
     *  出发城市和币种对应表
     */
    Map<String, String>  cityCurrency;


    public Map<String, String> getCityCurrency() {
        return cityCurrency;
    }

    public void setCityCurrency(Map<String, String> cityCurrency) {
        this.cityCurrency = cityCurrency;
    }

    public String getSmallMqSearchName() {
        return smallMqSearchName;
    }

    public void setSmallMqSearchName(String smallMqSearchName) {
        this.smallMqSearchName = smallMqSearchName;
    }

    public Boolean getSmallStartSendMq() {
        return isSmallStartSendMq;
    }

    public void setSmallStartSendMq(Boolean smallStartSendMq) {
        isSmallStartSendMq = smallStartSendMq;
    }

    public Boolean getSmallStartMqListenter() {
        return isSmallStartMqListenter;
    }

    public void setSmallStartMqListenter(Boolean smallStartMqListenter) {
        isSmallStartMqListenter = smallStartMqListenter;
    }



    @Value("${bigSearchUrl}")
    private String bigSearchUrl;

    @Value("${big_web_price}")
    private Double big_web_price;

    @Value("${cacheUrl}")
    private String cacheUrl;

    @Value("${addPrice}")
    private Integer addPrice;



    @Value("${peronNum}")
    private Integer peronNum;

    @Value("${isStartWebCache}")
    private Boolean isStartWebCache = true;

    public Integer getAddPrice() {
        return addPrice;
    }

    public void setAddPrice(Integer addPrice) {
        this.addPrice = addPrice;
    }

    public String getCacheUrl() {
        return cacheUrl;
    }

    public void setCacheUrl(String cacheUrl) {
        this.cacheUrl = cacheUrl;
    }

    public Double getBig_web_price() {
        return big_web_price;
    }

    public void setBig_web_price(Double big_web_price) {
        this.big_web_price = big_web_price;
    }

    public String getMqAdress() {
        return mqAdress;
    }

    public String getMqSearchName() {
        return mqSearchName;
    }

    public void setMqAdress(String mqAdress) {
        this.mqAdress = mqAdress;
    }

    public void setMqSearchName(String mqSearchName) {
        this.mqSearchName = mqSearchName;
    }

    public Integer getMqSearchListenerNum() {
        return mqSearchListenerNum;
    }

    public void setMqSearchListenerNum(Integer mqSearchListenerNum) {
        this.mqSearchListenerNum = mqSearchListenerNum;
    }


    public Boolean getStartSendMq() {
        return isStartSendMq;
    }

    public void setStartSendMq(Boolean startSendMq) {
        isStartSendMq = startSendMq;
    }

    public void setStartMqListenter(Boolean startMqListenter) {
        isStartMqListenter = startMqListenter;
    }

    public Boolean getStartMqListenter() {
        return isStartMqListenter;
    }

    public String getSearchUrl() {
        return searchUrl;
    }

    public void setSearchUrl(String searchUrl) {
        this.searchUrl = searchUrl;
    }

    public String getBigSearchUrl() {
        return bigSearchUrl;
    }

    public void setBigSearchUrl(String bigSearchUrl) {
        this.bigSearchUrl = bigSearchUrl;
    }

    public Integer getPeronNum() {
        return peronNum;
    }

    public void setPeronNum(Integer peronNum) {
        this.peronNum = peronNum;
    }

    public Boolean getStartWebCache() {
        return isStartWebCache;
    }

    public void setStartWebCache(Boolean startWebCache) {
        isStartWebCache = startWebCache;
    }
}
