package com.bjlt.spider.config;

import com.google.common.util.concurrent.ThreadFactoryBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.stereotype.Component;

import java.util.concurrent.*;


@Component
public class ThreadPool {


    static ThreadFactory factory = new ThreadFactoryBuilder().setNameFormat("pool-%d").build();

    @Bean
    public ExecutorService executorService() {

        return new ThreadPoolExecutor(5, 10, 30L,
                        TimeUnit.SECONDS, new LinkedBlockingDeque<>(1024), factory, new ThreadPoolExecutor.DiscardPolicy());
    }


}
