package com.bjlt.spider.controller;

import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.bean.ExchangeRateInstance;
import com.luyn.date.DateUtil;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.jms.JMSException;
import java.util.Date;
import java.util.Hashtable;
import java.util.List;

@RestController
public class SendController {


    @RequestMapping("search/start")
    public String send(){
        ExchangeRateInstance.getInstance().start();
        try {
            Thread.sleep(200L);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        return  ExchangeRateInstance.getInstance().getState()+"";
    }



    @RequestMapping("search/stop")
    public String stop(){
        ExchangeRateInstance.getInstance().stop();
        try {
            Thread.sleep(200L);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        return  ExchangeRateInstance.getInstance().getState()+"";
    }


    @RequestMapping("search/state")
    public String state(){
        return  ExchangeRateInstance.getInstance().getState()+"";
    }



    @RequestMapping("add")
    public String add(){
        try {
              ExchangeRateInstance.getInstance().createMessageConsumers();
        } catch (JMSException e) {
            e.printStackTrace();
        }
        return "消费者数量:"+ExchangeRateInstance.getInstance().getConsumerNumber();
    }


    @RequestMapping("remove")
    public String remove(){
        try {
            ExchangeRateInstance.getInstance().removeConsumer();
        } catch (JMSException e) {
            e.printStackTrace();
        }
        return "消费者数量:"+ExchangeRateInstance.getInstance().getConsumerNumber();
    }


    @RequestMapping("addSlepp")
    public String addSlepp(){
        ExchangeRateInstance.getInstance().addSleep();
        return "当前每次扔查询需求的睡眠时间:"+ExchangeRateInstance.getInstance().getSleep()+"毫秒";
    }


    @RequestMapping("removeSlep")
    public String removeSlepp(){
        ExchangeRateInstance.getInstance().removeSleep();
        return "当前每次扔查询需求的睡眠时间:"+ExchangeRateInstance.getInstance().getSleep()+"毫秒";
    }


    @RequestMapping("searchinfo")
    public String getSearchInfo(){
        Hashtable<String, List<Hashtable<String, String>>> searchmoiter = ExchangeRateInstance.getInstance().getSearchmoiter();
        String str ="";
        for (String key : searchmoiter.keySet()) {
            str +="<h3>"+key+"</h3>"+"<hr><br>";
            List<Hashtable<String, String>> hashtables = searchmoiter.get(key);
            for (int i = 0; i < hashtables.size(); i++) {
                Hashtable<String, String> stringStringHashtable = hashtables.get(i);
                String searhkey  =stringStringHashtable.get("searhkey");
                String pt  =stringStringHashtable.get("pt");
                String msg  =stringStringHashtable.get("msg");
                str +="<b>"+searhkey+"平台："+pt+"----->msg:"+msg +"</b><br>";
            }
        }

        return str;
    }


    @RequestMapping("searchnewinfo")
    public String getSearchInfos(){
        String str ="";
        Hashtable<String, List<Hashtable<String, String>>> searchmoiter = ExchangeRateInstance.getInstance().getSearchmoiters();
        for (int i =0; i < 5; i++) {
            String key = DateUtil.getFormatDate(new Date(System.currentTimeMillis()-i*60*1000), "yyyyMMDDHHmm");
            str +="<h3>"+key+"</h3>"+"<hr><br>";
            if(searchmoiter.containsKey(key)){
                List<Hashtable<String, String>> hashtables = searchmoiter.get(key);
                for (int j = 0; j< hashtables.size(); i++) {
                    Hashtable<String, String> stringStringHashtable = hashtables.get(j);
                    String searhkey  =stringStringHashtable.get("searhkey");
                    String pt  =stringStringHashtable.get("pt");
                    String msg  =stringStringHashtable.get("msg");
                    str +="<b>"+searhkey+"平台："+pt+"----->msg:"+msg +"</b><br>";
                }

            }
        }

        return str;
    }

}
