package com.bjlt.spider.dao.impl;

import com.bjlt.spider.bean.AirSourceLine;
import com.bjlt.spider.bean.AirSourceLineMapper;
import com.bjlt.spider.dao.IAirSourceLineDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.ResultSetExtractor;
import org.springframework.stereotype.Repository;


import javax.annotation.Resource;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Repository
public class AirSourceLineImpl implements IAirSourceLineDao {

    @Autowired
    JdbcTemplate jdbcTemplate;

    @Override
    public List<AirSourceLine> selectAllAirSourceLines() {

        String sql ="select se_airsource_line.*,sc_citycurrency.currency_code from se_airsource_line " +
                " LEFT JOIN sc_citycurrency on se_airsource_line.from_city = sc_citycurrency.stationCode" +
                " where se_airsource_line.air_source_id = 1 " +
                " and sc_citycurrency.currency_code is NOT NULL and se_airsource_line.status = 1";

        List<AirSourceLine> airSourceLines = jdbcTemplate.query(sql, new AirSourceLineMapper());
        return airSourceLines;
    }


    /**
     * 获取所有的城市对应币种
     * @return
     */
    @Override
    public Map<String, String> getAllCityCurrency() {
        String sql = "SELECT currency_code,stationCode FROM sc_citycurrency";


        Map<String,String> map = new HashMap<>();
        jdbcTemplate.query(sql, new ResultSetExtractor() {
            @Override
            public Object extractData(ResultSet resultSet) throws SQLException, DataAccessException {
                 while (resultSet != null && resultSet.next()){
                     String  currency_code = resultSet.getString("currency_code");
                     String stationCode = resultSet.getString("stationCode");
                     map.put(stationCode,currency_code);

                 }


                return map;
            }
        });


        return map;
    }

}
