package com.bjlt.spider.dao.impl;

import com.bjlt.spider.dao.SeAirsourceLineDao;
import com.bjlt.spider.entity.SeAirsourceLine;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.*;

import org.springframework.stereotype.Repository;

import java.util.*;
import java.util.stream.*;
/**
* se_airsource_line
*/
@Repository
public class SeAirsourceLineDaoImpl implements SeAirsourceLineDao {
	@Autowired
	private JdbcTemplate jdbcTemplate;
	@Override
	public List<SeAirsourceLine> listPageSeAirsourceLine(SeAirsourceLine seAirsourceLine) {
		StringBuffer s=new StringBuffer();
		String select = "select id, air_source_id, from_city, from_city_name, to_city, to_city_name, from_country, edit_user," +
				" update_time, add_time, status, before_date,searchdate from se_airsource_line ";
		s.append(select );
        Map<String,Object> m=map(seAirsourceLine);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
		seAirsourceLine.setTotal(count(where,m.values().toArray()));
		s.append(where);


		String limit = " limit " + (seAirsourceLine.getStart()-1)*seAirsourceLine.getSize() + "," + seAirsourceLine.getSize();

		s.append(limit);
		RowMapper<SeAirsourceLine> rowMapper = new BeanPropertyRowMapper<SeAirsourceLine>(SeAirsourceLine.class);
		List<SeAirsourceLine> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());

		return list;
	}



    @Override
    public void insertSelective(SeAirsourceLine seAirsourceLine) {
		StringBuffer s = new StringBuffer();
		s.append("insert into se_airsource_line(");
        Map<String, Object> m = map(seAirsourceLine);
        s.append(String.join(",", m.keySet()));
        s.append(") values (");
		List<String> wenhao = m.keySet().stream().map(t -> "?").collect(Collectors.toList());

	s.append(String.join(",", wenhao));
		s.append(")");
        System.out.println(s.toString());
        jdbcTemplate.update(s.toString(), m.values().toArray());
	}

    @Override
    public void updateByPrimaryKeySelective(SeAirsourceLine seAirsourceLine) {
		StringBuffer s = new StringBuffer();
		s.append("update se_airsource_line set ");
        Map<String, Object> m = map(seAirsourceLine);
        String update = m.keySet().stream().map(t -> t + "=?").collect(Collectors.joining(","));
        s.append(update);
        System.out.println(update);
        s.append(" where 	id=" + seAirsourceLine.getId());
        jdbcTemplate.update(s.toString(), m.values().toArray());

	}



    @Override
    public List<SeAirsourceLine> listSeAirsourceLine(SeAirsourceLine seAirsourceLine) {
        StringBuffer s=new StringBuffer();
        String select = "select id, air_source_id, from_city, from_city_name, " +
				"to_city, to_city_name, from_country, edit_user, update_time, add_time, status, before_date,searchdate from se_airsource_line ";
        s.append(select );
        Map<String,Object> m=map(seAirsourceLine);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<SeAirsourceLine> rowMapper = new BeanPropertyRowMapper<SeAirsourceLine>(SeAirsourceLine.class);
        List<SeAirsourceLine> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());

        return list;
	}
    @Override
	public void  deleteSeAirsourceLine(SeAirsourceLine seAirsourceLine){
		StringBuffer s=new StringBuffer();
		String select = "delete  from se_airsource_line ";
        Map<String,Object> m=map(seAirsourceLine);
        s.append(select);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
		jdbcTemplate.update(s.toString(),m.values().toArray());

	}

	@Override
	public void updateSeAirsourceLine(String fromStation, String toStation) {
		String sql ="update se_airsource_line set status = ? where from_city =? and to_city = ?";
		Object[] args = {0,fromStation,toStation};
		jdbcTemplate.update(sql,args);
	}

	private static Map<String,Object> map(SeAirsourceLine seAirsourceLine) {
		Map<String,Object> map=new HashMap();
    	if (seAirsourceLine.getId() != null) {
            map.put("id",seAirsourceLine.getId());
    	}
    	if (seAirsourceLine.getAirSourceId() != null) {
            map.put("air_source_id",seAirsourceLine.getAirSourceId());
    	}
    	if (seAirsourceLine.getFromCity() != null && !seAirsourceLine.getFromCity().equals("")) {
            map.put("from_city",seAirsourceLine.getFromCity());
    	}
    	if (seAirsourceLine.getFromCityName() != null && !seAirsourceLine.getFromCityName().equals("")) {
            map.put("from_city_name",seAirsourceLine.getFromCityName());
    	}
    	if (seAirsourceLine.getToCity() != null && !seAirsourceLine.getToCity().equals("")) {
            map.put("to_city",seAirsourceLine.getToCity());
    	}
    	if (seAirsourceLine.getToCityName() != null && !seAirsourceLine.getToCityName().equals("")) {
            map.put("to_city_name",seAirsourceLine.getToCityName());
    	}
    	if (seAirsourceLine.getFromCountry() != null && !seAirsourceLine.getFromCountry().equals("")) {
            map.put("from_country",seAirsourceLine.getFromCountry());
    	}
    	if (seAirsourceLine.getEditUser() != null && !seAirsourceLine.getEditUser().equals("")) {
            map.put("edit_user",seAirsourceLine.getEditUser());
    	}
    	if (seAirsourceLine.getUpdateTime() != null && !seAirsourceLine.getUpdateTime().equals("")) {
            map.put("update_time",seAirsourceLine.getUpdateTime());
    	}
    	if (seAirsourceLine.getAddTime() != null && !seAirsourceLine.getAddTime().equals("")) {
            map.put("add_time",seAirsourceLine.getAddTime());
    	}
    	if (seAirsourceLine.getStatus() != null) {
            map.put("status",seAirsourceLine.getStatus());
    	}
    	if (seAirsourceLine.getBeforeDate() != null) {
            map.put("before_date",seAirsourceLine.getBeforeDate());
    	}
		if (seAirsourceLine.getSearchDate() != null) {
			map.put("searchdate", seAirsourceLine.getSearchDate());
		}

		return map;

	}
	private Integer count(String where,Object[] objects) {
		String sql = "select count(*) from se_airsource_line " + where;
		return jdbcTemplate.queryForObject(sql, Integer.class,objects);
	}




}
