package com.bjlt.spider.job;

import com.alibaba.fastjson.JSON;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.entity.ScPolicy;
import com.bjlt.spider.service.ScPolicyService;
import com.bjlt.spider.utils.ActiveMQUtil;
import com.luyn.json.JsonUtils;
import lombok.extern.slf4j.Slf4j;
import org.openqa.selenium.json.Json;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.jms.JMSException;
import java.util.List;

/**
 * @author: luyanan0718@163.com
 * @create :2018/4/10 18:25
 * @introduce : 小循环任务
 **/

@Slf4j
@Component
public class SmallLoopJob {

	@Autowired
	Config config;


	@Autowired
	ScPolicyService scPolicyService;

	/**
	 * 订单关联
	 */
	@Scheduled(fixedDelay = 1800000)
	public void worker() {

		// 控制是否往mysq 扔消息
		if (config != null && config.getSmallStartSendMq()) {
			ScPolicy scPolicy = new ScPolicy();
			scPolicy.setStatus(1);
			List<ScPolicy> scPolicies = scPolicyService.selectNonRepeatingRoute("1");
			log.info("共查询到需要循环的政策--->{}条",scPolicies.size());
			if (scPolicies != null && scPolicies.size() > 0) {

				scPolicies.stream().forEach(policies -> {
				 	String json = JSON.toJSONString(policies);
					try {
						ActiveMQUtil.sendMessage(config.getMqAdress(),config.getSmallMqSearchName(),json);
						log.info("发送给mq的队列{}消息{}成功",config.getSmallMqSearchName(),json);
					} catch (JMSException e) {
						e.printStackTrace();
					}
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}

				});


			}


			System.out.println(JSON.toJSONString(scPolicies));


		}


		log.info("小循环中");
	}


}
