package com.bjlt.spider.listener;

import com.bjlt.spider.entity.SeAirsourceLine;
import com.bjlt.spider.service.IAirSoureLineService;
import com.bjlt.spider.service.SeAirsourceLineService;
import com.bjlt.spider.utils.SpringContextUtils;
import com.bjlt.spider.utils.request.ToolUtils;
import com.luyn.date.DateUtil;
import lombok.extern.slf4j.Slf4j;


import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * MQ 的消费者
 */
@Slf4j
public class AirSoureLineListenter implements MessageListener {


    private IAirSoureLineService airSoureLineService = SpringContextUtils.getBean(IAirSoureLineService.class);


    SeAirsourceLineService seAirsourceLineService= SpringContextUtils.getBean(SeAirsourceLineService.class);




    @Override
    public void onMessage(Message message) {
        TextMessage textMsg = (TextMessage) message;

        try {
            String searchKey = ((TextMessage) message).getText();
            log.info("消费信息："+searchKey);
            if (!ToolUtils.isEmpty(searchKey)) {
                //判断是否进行查询
                String[] split = searchKey.split("[_]");
                if (split.length > 4) {
                    int id = Integer.parseInt(split[4]);
                    String fromDate = split[2];
                    SeAirsourceLine seAirsourceLine = new SeAirsourceLine();
                    seAirsourceLine.setId(id);
                    List<SeAirsourceLine> seAirsourceLines = new ArrayList<>();
                    try {
                      seAirsourceLines = seAirsourceLineService.listSeAirsourceLine(seAirsourceLine);
                    }catch (Exception e){
                        return;
                    }

                    if (ToolUtils.isEmpty(seAirsourceLine)) {
                        return;
                    }
                    SeAirsourceLine newSeAir = seAirsourceLines.get(0);
                    //如果当前航线已经拉黑则结束
                    if(newSeAir.getStatus()==0){
                        return;
                    }
                    //当前db中的日期
                    String searchDate = newSeAir.getSearchDate();


                    if (ToolUtils.isEmpty(searchDate)) {
                        airSoureLineService.processSearch(searchKey);
                    } else {
                        //db中的日期
                        Date searchNewDate = DateUtil.getFormatDate(fromDate, "yyyy-MM-dd");
//
//                        String formatSearchDate = DateUtil.getFormatDate(DateUtil.getBeforeDay(formatDate, -1), "yyyy-MM-dd");
//                        if (!formatSearchDate.equals(fromDate)) {
//                            return;
//                        }
                        if(searchNewDate.before(DateUtil.getBeforeDay(new Date(), -60))){
                            airSoureLineService.processSearch(searchKey);
                        }
                    }
                    //判断查询日期是不是第60天 如果是 则更新成当前时间
                    String format60Date = DateUtil.getFormatDate(DateUtil.getBeforeDay(new Date(), -60), "yyyy-MM-dd");
                    if(format60Date.equals(fromDate)){
                        seAirsourceLine.setSearchDate(fromDate);
                    }else{
                        //db中的日期
                        Date dbDate = DateUtil.getFormatDate(searchDate, "yyyy-MM-dd");
                        Date searchDateCurrent = DateUtil.getFormatDate(fromDate, "yyyy-MM-dd");
                        //db中日期早于查询日期 更新为查询日期
                        if(dbDate.before(searchDateCurrent)){
                            //查询日期比60天后的日期要早 更新为查询日期
                            if(searchDateCurrent.before(DateUtil.getBeforeDay(new Date(),-60))){
                                seAirsourceLine.setSearchDate(fromDate);
                            }else{
                                seAirsourceLine.setSearchDate(DateUtil.getFormatDate(DateUtil.getBeforeDay(new Date(),-3), "yyyy-MM-dd"));
                            }

                        }else{
                            seAirsourceLine.setSearchDate(searchDate);
                        }
                    }
                    // 此处更新db
                    try{
                        seAirsourceLineService.updateByPrimaryKeySelective(seAirsourceLine);
                    }catch (Exception e){

                    }


                } else {
                    airSoureLineService.processSearch(searchKey);
                }


            }
        } catch (JMSException e) {
            e.printStackTrace();
        }
    }
}
