package com.bjlt.spider;

import com.bjlt.spider.datasources.DynamicDataSourceConfig;
import com.luyn.config.LuynConfig;
import com.luyn.http.config.HttpConfig;
import com.luyn.http.debug.Debug;
import com.luyn.log.SysLoggerConfig;
import com.luyn.log.SysLoggerLevel;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.context.annotation.Import;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter;

//
//@EnableFeignClients
//@EnableDiscoveryClient
//@EnableTransactionManagement
//@EnableRetry

@SpringBootApplication(exclude = {DataSourceAutoConfiguration.class})
@Import({DynamicDataSourceConfig.class})
public class loopServiceApplication extends WebMvcConfigurerAdapter {


    public static void main(String[] args) {
        LuynConfig.setHttpClientDebug_Level(Debug.Level.NONE);
        HttpConfig.setDebug(Debug.Level.NONE);
        LuynConfig.setHttpClientDebug_Level(Debug.Level.NONE);
        SysLoggerConfig.setLevels(new SysLoggerLevel[]{SysLoggerLevel.ALL});
        SpringApplication.run(loopServiceApplication.class, args);
    }


}