package com.bjlt.spider.runner;

import com.bjlt.spider.bean.ExchangeRateInstance;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.listener.AirSoureLineListenter;
import org.apache.activemq.ActiveMQConnectionFactory;
import org.apache.activemq.command.ActiveMQQueue;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import javax.jms.*;


/**
 * 启动消费者
 */
@Component
public class AirSourceLineRunner implements CommandLineRunner {

    @Autowired
    Config config;

    @Override
    public void run(String... args) throws Exception {
      if(config.getStartMqListenter()){
          System.out.println("查询MQ的消费者已经开启~~~~~~~~~~~~~~~~~~~~~");
          new Thread(()->{
              String mqAdress = config.getMqAdress();
              String mqName = config.getMqSearchName();
              ConnectionFactory cf = new ActiveMQConnectionFactory(mqAdress);
              Connection conn = null;
              Session session = null;
              try {
                  conn = cf.createConnection();
                  Destination destination = new ActiveMQQueue(mqName);

              //    ExchangeRateInstance.getInstance().setSession(session);
                //  ExchangeRateInstance.getInstance().setDestination(destination);
                  for (int i = 0; i < config.getMqSearchListenerNum(); i++) {
                      session = conn.createSession(false, Session.AUTO_ACKNOWLEDGE);
//                      ExchangeRateInstance.getInstance().createMessageConsumers();
                      MessageConsumer consumer = session.createConsumer(destination);
                      consumer.setMessageListener(new AirSoureLineListenter());
                  }
                  conn.start();


              } catch (JMSException e) {
                  e.printStackTrace();
              }
          }).start();
      }




    }
}
