package com.bjlt.spider.runner;

import com.bjlt.spider.bean.ExchangeRateInstance;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.entity.ScCitycurrency;
import com.bjlt.spider.entity.SeAirsourceLine;
import com.bjlt.spider.service.ScCitycurrencyService;
import com.bjlt.spider.service.SeAirsourceLineService;
import com.bjlt.spider.utils.ActiveMQUtil;
import com.bjlt.spider.utils.request.ToolUtils;
import com.luyn.date.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import javax.jms.JMSException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;


/**
 * 读取数据库中的航线数据扔MQ
 */
@Component
public class HoteAireSoureLineRunner implements CommandLineRunner {



    @Autowired
    SeAirsourceLineService seAirsourceLineService;


    @Autowired
    ScCitycurrencyService scCitycurrencyService;

    @Autowired
    Config config;


    @Override
    public void run(String... args) throws Exception {
        if (config.getStartSendMq()) {
            System.out.println("向MQ发送Hot查询key已经开启~~~~~~~~~~~~~~~~~~~~");
            new Thread(
                    () -> {
                        while (true){
                            String str ="PEK|SZB_CAN|DMK_SHA|SZB_KMG|DMK_DMK|HKT_CAN|SZB_HKT|DMK_CTU|SZB_DMK|KMG_SZX|SZB_KMG|SZB_SHA|DMK_DMK|CAN_XIY|SZB_SZX|DMK_CSX|CNX_SZB|SZX_SZB|CAN_CSX|DMK_DMK|SZX_CKG|DMK_DMK|CKG_DMK|SHA_CNX|DMK_KMG|HKT_HGH|SZB_DMK|XZM_CAN|BKI_BKI|TWU_SZB|SHA_TWU|SZB_CKG|SZB_SZB|PEK_HKT|CNX_TWU|BKI_DMK|CSX_PEN|SZB_CTU|DMK_WUH|DMK_XIY|DMK_SZB|BKI_SZB|CTU_DMK|XIY_SZB|TWU_BKI|SZB_SZX|BKI_XZM|DMK_CNX|CSX_HGH|CNX_BKI|CAN_NNG|SZB_HKT|KMG_WUH|BKI_SZB|PEN_SZB|KMG_HGH|BKI_CSX|SZB_LGK|SZB_HKG|DMK_DMK|HKG_DMK|WUH_DMK|CNX_DMK|KBV_CNX|HKG_CNX|UTP_BKI|SZX_XZM|CNX_SZB|XIY_WUH|HKT_CNX|HKT_UTP|CNX_SWA|DMK_HKT|SZB_CNX|HGH_BKI|WUH_SZB|NNG_NNG|UTP_BKI|HGH_XZM|SZB_CAN|JHB_SZB|LGK_SWA|SZB_KBV|DMK_SGL|CAN_CAN|SGL_XZM|HKT_HKG|SZB_DPS|SZB_KWL|SZB_HKG|CNX_SZB|HKG_CNX|XZM_DPS|SZB_CAN|LGK_HKT|XZM_SZB|HGH_UTP|NNG_JHB|CAN_HKT|WUH_DMK|SWA_XSP|SZB_BKI|HKG_KHN|UTP_DMK|CTU_SZB|CKG_HKG|BKI_RML|SZB_SZB|SWA_KBV|CNX_DMK|PNH_HKG|HKT_SZB|XZM_SZB|CSX_DMK|SZB_HKT|HKG_PEN|LGK_SHA|SGL_LGK|CAN_HKT|UTP_SZB|DPS_SZB|HKT_UTP|HKT_SGL|HKG_TAG|SGL_JKT|SZB_SGN|SZB_WUH|SZB_XZM|UTP_HDY|DMK_LGK|PEN_RGN|DMK_UTP|KHN_SZB|JHB_SGL|XZM_PNH|DMK_UTP|XZM_KLO|SGL_SGL|SHA_SHA|KLO_SZB|XSP_JHB|SZB_CNX|SZB_MPH|SGL_DMK|SZB_SZB|DMK_MEL|SZB_CEB|SGL_SZB|KWL_XZM|SGL_SGL|TAG_SZB|RML_HKG|SGL_PNH|SZB_SHA|DPS_SGL|CEB_DPS|DMK_SZX|KCH_KBV|SZB_KLO|SHA_SGL|KLO_REP|DMK_JHB|XZM_DMK|HDY_VTE|DMK_SGL|MPH_SZB|PNH_DMK|NKG_SYD|SZB_CEI|DMK_NKG|DMK_PEN|BKI_CNX|KBV_XZM|JHB_SZB|JKT_SZB|TGG_PEK|DPS_LOP|SZB_SZB|DPS_URT|DMK_TGG|SZB_XSP|DMK_REP|SZB_TSA|SZB_DMK|HGH_KCH|SZX_MLE|SZB_SZB|WUH_HGH|DMK_LGK|SZX_DPS|JKT_SZB|CNX_DMK|RGN_SZB|KBV_SZB|DMK_DMK|CEI";
                            String[] split = str.split("[_]");
                            for (int i = 0; i < split.length; i++) {
                                String aaa = split[i];
                                String fromCity =aaa.split("[|]")[0];
                                String toCity = aaa.split("[|]")[1];
                                for (int j = 1; j < 60; j++) {
                                    System.out.println("is  send message to mq :" + ExchangeRateInstance.getInstance().getState());
                                    //判断是否开启扔MQ
                                    if (!ExchangeRateInstance.getInstance().getState()) {
                                        while (true) {
                                            if (ExchangeRateInstance.getInstance().getState()) {
                                                break;
                                            }
                                            try {
                                                Thread.sleep(2000L);
                                            } catch (InterruptedException e) {
                                                e.printStackTrace();
                                            }
                                        }
                                    }
                                    String fromDate = DateUtil.getFormatDate(DateUtil.getBeforeDay(new Date(), -6-j),"yyyy-MM-dd");
                                    ScCitycurrency scCitycurrency = new ScCitycurrency();
                                    scCitycurrency.setStationCode(fromCity);
                                    List<ScCitycurrency> scCitycurrencies = scCitycurrencyService.listScCitycurrency(scCitycurrency);
                                    if(ToolUtils.isEmpty(scCitycurrencies)){
                                        continue;
                                    }
                                    String searchKey = fromCity + "_" + toCity + "_" + fromDate + "_" + scCitycurrencies.get(0).getCurrencyCode();

                                    try {
                                        ActiveMQUtil.sendMessage(config.getMqAdress(), config.getMqSearchName(), searchKey);
                                    } catch (JMSException e) {
                                        e.printStackTrace();
                                    }
                                    //每次睡眠多久
                                    try {
                                        Thread.sleep(ExchangeRateInstance.getInstance().getSleep());
                                    } catch (InterruptedException e) {
                                        e.printStackTrace();
                                    }
                                }
                            }

                            try {
                                Thread.sleep(5000L);
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            }
                        }

                    }
            ).start();
        }


    }
}
