package com.bjlt.spider.runner;

import com.bjlt.spider.bean.AirSourceLine;
import com.bjlt.spider.bean.ExchangeRateInstance;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.entity.ScCitycurrency;
import com.bjlt.spider.entity.SeAirsourceLine;
import com.bjlt.spider.service.IAirSoureLineService;
import com.bjlt.spider.service.ScCitycurrencyService;
import com.bjlt.spider.service.SeAirsourceLineService;
import com.bjlt.spider.utils.ActiveMQUtil;
import com.bjlt.spider.utils.request.ToolUtils;
import com.luyn.date.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import javax.jms.JMSException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;


/**
 * 读取数据库中的航线数据扔MQ
 */
@Component
public class NewAireSoureLineRunner implements CommandLineRunner {



    @Autowired
    SeAirsourceLineService seAirsourceLineService;


    @Autowired
    ScCitycurrencyService scCitycurrencyService;

    @Autowired
    Config config;




    @Override
    public void run(String... args) throws Exception {
        if (config.getStartSendMq()) {
            System.out.println("向MQ发送查询key已经开启~~~~~~~~~~~~~~~~~~~~");
            new Thread(
                    () -> {
                        while (true){
                           try{
                               SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
                               List<SeAirsourceLine> seAirsourceLines = seAirsourceLineService.newlistSeAirsourceLine(true);
                               for (SeAirsourceLine airSoure : seAirsourceLines) {
                                   String currentDateString = airSoure.getSearchDate();
                                   Date currentDate =DateUtil.getFormatDate(currentDateString, "yyyy-MM-dd");
                                   if(currentDate.after(DateUtil.getBeforeDay(new Date(),-60))){
                                       Date beforeDay = DateUtil.getBeforeDay(new Date(), -3);
                                       airSoure.setSearchDate(DateUtil.getFormatDate(beforeDay,"yyyy-MM-dd"));
                                       seAirsourceLineService.updateByPrimaryKeySelective(airSoure);
                                       continue;
                                   }
                                   for (int i = 1; i < 60; i++) {
                                       System.out.println("is  send message to mq :" + ExchangeRateInstance.getInstance().getState());
                                       //判断是否开启扔MQ
                                       if (!ExchangeRateInstance.getInstance().getState()) {
                                           while (true) {
                                               if (ExchangeRateInstance.getInstance().getState()) {
                                                   break;
                                               }
                                               try {
                                                   Thread.sleep(2000L);
                                               } catch (InterruptedException e) {
                                                   e.printStackTrace();
                                               }
                                           }
                                       }
                                       String fromCity = airSoure.getFromCity();
                                       String toCity = airSoure.getToCity();
                                       Date beforeDay = DateUtil.getBeforeDay(DateUtil.getFormatDate(airSoure.getSearchDate(), "yyyy-MM-dd"), -i);
                                       //如果当前发查询的日期超过当前时间60天则不发
                                       if( !beforeDay.before( DateUtil.getBeforeDay(new Date(), -60))){
                                           break;
                                       }
                                       String fromDate = ToolUtils.isEmpty(airSoure.getSearchDate())?sdf.format(DateUtil.getBeforeDay(new Date(), -6-i)): sdf.format( beforeDay);
                                       ScCitycurrency scCitycurrency = new ScCitycurrency();
                                       scCitycurrency.setStationCode(fromCity);
                                       List<ScCitycurrency> scCitycurrencies = scCitycurrencyService.listScCitycurrency(scCitycurrency);
                                       if(ToolUtils.isEmpty(scCitycurrencies)){
                                           continue;
                                       }
                                       String searchKey = fromCity + "_" + toCity + "_" + fromDate + "_" + scCitycurrencies.get(0).getCurrencyCode()+"_"+airSoure.getId();
                                       try {
                                           ActiveMQUtil.sendMessage(config.getMqAdress(), config.getMqSearchName(), searchKey);
                                       } catch (JMSException e) {
                                           e.printStackTrace();
                                       }
                                       //每次睡眠多久
                                       try {
                                           Thread.sleep(ExchangeRateInstance.getInstance().getSleep());
                                       } catch (InterruptedException e) {
                                           e.printStackTrace();
                                       }


                                   }
                               }


                               try {
                                   Thread.sleep(5000L);
                               } catch (InterruptedException e) {
                                   e.printStackTrace();
                               }


                           }catch (Exception e){

                           }

                        }



                    }
            ).start();
        }


    }
}
