package com.bjlt.spider.runner.small;

import com.bjlt.spider.config.Config;
import com.bjlt.spider.listener.AirSoureLineListenter;
import com.bjlt.spider.runner.ActiveMQConnectionHandler;
import lombok.extern.slf4j.Slf4j;
import org.apache.activemq.ActiveMQConnectionFactory;
import org.apache.activemq.command.ActiveMQQueue;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

import javax.jms.*;
import java.util.concurrent.ExecutorService;

/**
 * @author: luyanan0718@163.com
 * @create :2018/4/10 18:52
 * @introduce :  小循环的消费者
 **/

@Slf4j
@Component
@Order(10)
public class SmallAirSourceLineRunner implements CommandLineRunner {


	@Autowired
	Config config;


	@Autowired
	ExecutorService executorService;

	@Override
	public void run(String... strings) throws Exception {
		//控制是否开启消费者
		if (config != null && config.getSmallStartMqListenter()) {

			new Thread(() -> {
				String mqAdress = config.getMqAdress();
				// 消费队列
				String mqName = config.getSmallMqSearchName();
				log.info("mq的消费者开启,队列名称为--->{}",mqName);
				ConnectionFactory cf = new ActiveMQConnectionFactory(mqAdress);
				Connection conn = null;
				Session session = null;
				try {
					conn = cf.createConnection();
					Destination destination = new ActiveMQQueue(mqName);
					session = conn.createSession(false, Session.AUTO_ACKNOWLEDGE);
					MessageConsumer consumer = session.createConsumer(destination);
					consumer.setMessageListener(new SmallAirSoureLineListenter());
					for (int i = 0; i < 3; i++) {
						log.info("小循环执行的线程为--->{}",i);
						executorService.execute(new ActiveMQConnectionHandler(conn, session, destination));
					}
//
//					if(Too)

				} catch (JMSException e) {
					e.printStackTrace();
				}


			}).start();


		}


	}
}
