package com.bjlt.spider.runner.small;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.entity.ScPolicy;
import com.bjlt.spider.service.SmallAirLineService;
import com.bjlt.spider.utils.SpringContextUtils;
import lombok.extern.slf4j.Slf4j;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;

/**
 * @author: luyanan0718@163.com
 * @create :2018/4/11 9:50
 * @introduce : MQ的消费者
 **/

@Slf4j
public class SmallAirSoureLineListenter implements MessageListener {



	private SmallAirLineService smallAirLineService= SpringContextUtils.getBean(SmallAirLineService.class);




	@Override
	public void onMessage(Message message) {


		TextMessage textMsg = (TextMessage) message;
		try {

			String searchKey = ((TextMessage) message).getText();

			JSONObject jsonObject = JSONObject.parseObject(searchKey);
			ScPolicy scPolicy = JSON.toJavaObject(jsonObject, ScPolicy.class);

			log.info("小循环接受的消息为--->{}", JSON.toJSONString(scPolicy));
			smallAirLineService.worker(scPolicy);

//			Thread.sleep(10000);
		} catch (JMSException e) {
			e.printStackTrace();
		}


	}
}
