package com.bjlt.spider.thread;

import com.bjlt.spider.config.Config;
import com.bjlt.spider.utils.SpringContextUtils;
import com.bjlt.spider.utils.request.ToolUtils;
import com.luyn.http.okhttp.OkHttpDownLoader;
import lombok.extern.slf4j.Slf4j;


@Slf4j
public class SendCacheThread extends  Thread{

    private String html;

    private Config config = SpringContextUtils.getBean(Config.class);

    public SendCacheThread(String html) {
        this.html = html;
    }

    @Override
    public void run() {
        if(config.getStartWebCache()){
            if(!ToolUtils.isEmpty(html)){
                try {
                    String asString = OkHttpDownLoader.textBody(config.getCacheUrl()).json(html).okhttpexecute().asString();
                    log.info("扔缓存回调结果:"+asString);
                }catch (Exception e){
                    log.info(e.getMessage());
                }
            }
        }else{
            log.info("回调web缓存未开启");
        }
    }
}
