package com.bjlt.spider.utils;

import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.bean.ExchangeRateInstance;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.dao.ScExchangeRateDao;
import com.bjlt.spider.entity.ScExchangeRate;
import com.bjlt.spider.entity.SourceEnum;
import com.bjlt.spider.service.impl.AirSoureLineServiceImpl;
import com.bjlt.spider.utils.request.ToolUtils;
import com.luyn.http.okhttp.OkHttpDownLoader;
import com.luyn.log.SysLogger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author: luyanan0718@163.com
 * @create :2018/4/11 10:50
 * @introduce : 循环的工具类
 **/
@Component
public class LoopCommonUtils {
	private static final SysLogger logger = SysLogger.getSysLogger(LoopCommonUtils.class);
	@Autowired
	ScExchangeRateDao scExchangeRateDao;



	/**
	 * @param airSource
	 * @param fromStation
	 * @param toStation
	 * @param fromDate
	 * @param currency
	 * @param retDate
	 * @return
	 */
	public   String searchData(String airSource, String fromStation, String toStation, String fromDate, String currency, String retDate, Config config) {

		JSONObject reqJSON = new JSONObject();
		reqJSON.put("adultNum", "3");
		reqJSON.put("airSource", airSource);
		reqJSON.put("childNum", "0");
		reqJSON.put("formCity", fromStation);
		reqJSON.put("toCity", toStation);
		reqJSON.put("fromDate", fromDate);
		reqJSON.put("currency", currency);
		reqJSON.put("retDate", retDate);
		//单程票还是回程票
		reqJSON.put("tripType", "2");
		logger.info(SysLogger.builder().logFilePath("searchlog").isCreateFile(true).name("searchlog").message("查询参数--->"+reqJSON.toString()).build());
		if (airSource.equals(SourceEnum.AK_WEB.getSourceName())) {
			return OkHttpDownLoader.textBody(config.getSearchUrl()).json(reqJSON.toString()).okhttpexecute().asString();
		} else {
			return OkHttpDownLoader.textBody(config.getBigSearchUrl()).json(reqJSON.toString()).okhttpexecute().asString();
		}
	}



	/**
	 * 获取汇率
	 * @param currency
	 * @return
	 */
	public  Double getFinalRate(String currency) {
		//做了一个缓存 当天缓存有则用 没有重新拿
		Double exchangeRate = ExchangeRateInstance.getInstance().getExchangeRate(currency);
		if(ToolUtils.isEmpty(exchangeRate)){
			ScExchangeRate scExchangeRate = new ScExchangeRate();
			scExchangeRate.setExchangeCurrency("CNY");
			scExchangeRate.setForeCurrency(currency);
			scExchangeRate.setGroupId("1");
			List<ScExchangeRate> scExchangeRates = scExchangeRateDao.listScExchangeRate(scExchangeRate);
			Double finalRate =null;
			if(!ToolUtils.isEmpty(scExchangeRates)){
				finalRate = scExchangeRates.get(0).getFinalRate();
				ExchangeRateInstance.getInstance().putExchangeRate(currency,finalRate);
			}
			return  finalRate;
		}else{
			return  exchangeRate;
		}
	}

}
